unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Ping, StdCtrls, ExtCtrls, TeeProcs, TeEngine, Chart, Series, Menus,
  ComCtrls, shellapi;

type
  TformMenuPrincipal = class(TForm)
    Ping1: TPing;
    mLog: TMemo;
    Chart1: TChart;
    Timer1: TTimer;
    Series1: TBarSeries;
    Chart2: TChart;
    Series2: TLineSeries;
    C2Popup: TPopupMenu;
    ShowLegend2: TMenuItem;
    be: TStatusBar;
    Panel1: TPanel;
    Label1: TLabel;
    bPing: TButton;
    bCancelar: TButton;
    txtHost: TComboBox;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    ShowLabels2: TMenuItem;
    C1Popup: TPopupMenu;
    ShowLegend1: TMenuItem;
    ShowLabels1: TMenuItem;
    Label2: TLabel;
    txtNumIntentos: TEdit;
    LWEB: TLabel;
    procedure bPingClick(Sender: TObject);
    procedure Ping1Display(Sender: TObject; Icmp: TObject; Msg: String);
    procedure Ping1DnsLookupDone(Sender: TObject; Error: Word);
    procedure bCancelarClick(Sender: TObject);
    procedure Ping1EchoRequest(Sender: TObject; Icmp: TObject);
    procedure Ping1EchoReply(Sender: TObject; Icmp: TObject; Error: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Series1AfterAdd(Sender: TChartSeries; ValueIndex: Integer);
    procedure ShowLegend1Click(Sender: TObject);
    procedure ShowLegend2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ShowLabels1Click(Sender: TObject);
    procedure ShowLabels2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LWEBClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.DFM}
var
  MMax, MMin, MMed, numeroSaltos, SaltoMax: integer;


procedure TformMenuPrincipal.bPingClick(Sender: TObject);
begin
  SaltoMax := SaltoMax + 1;
  if SaltoMax > StrToIntDef(txtNumIntentos.Text, 60) then
  begin
    bCancelar.Enabled := false;
    Exit;
  end;

  if numeroSaltos = 0 then
  begin
    SaltoMax := 0;
    mLog.Clear;
    Chart1.Title.Text.Clear;
    Chart1.Title.Text.Add(txtHost.Text);
    Series1.Clear;
    MMax := 0;
    MMin := 99999;
    MMed := 0;
    Chart2.Title.Text.Clear;
    Chart2.Title.Text.Add(txtHost.Text);
    Series2.Clear;
  end;

  Inc(numeroSaltos);
  mLog.Lines.Add(' ');
  mLog.Lines.Add('Salto: ' + IntToStr(numeroSaltos));
  mLog.Lines.Add('Resolviendo host ''' + txtHost.Text + '''');
  bPing.Enabled := false;
  bCancelar.Enabled := true;
  Application.ProcessMessages;
  Ping1.DnsLookup(txtHost.Text);
end;


procedure TformMenuPrincipal.Ping1DnsLookupDone(Sender: TObject; Error: Word);
begin
  bCancelar.Enabled := false;
  bPing.Enabled   := true;

  if Error <> 0 then
  begin
    mLog.Lines.Add('Host desconocido ''' + txtHost.Text + '''');
    Exit;
  end;

  mLog.Lines.Add('Host ''' + txtHost.Text + ''' IP: ' + Ping1.DnsResult);
  Ping1.Address := Ping1.DnsResult;
  Ping1.Ping;
end;


procedure TformMenuPrincipal.Ping1Display(Sender: TObject; Icmp: TObject; Msg: String);
begin
  mLog.Lines.Add(Msg);
end;


procedure TformMenuPrincipal.bCancelarClick(Sender: TObject);
begin
  if Timer1.Enabled then
  begin
    Timer1.Enabled := False;
  end;

  if not bCancelar.Enabled then
  begin
    Sleep(0100);
    Application.ProcessMessages;
  end;

  numeroSaltos := 0;

  Ping1.CancelDnsLookup;

  bCancelar.Enabled := False;
end;


procedure TformMenuPrincipal.Ping1EchoRequest(Sender: TObject; Icmp: TObject);
begin
  mLog.Lines.Add('Enviando ' + IntToStr(Ping1.Size) + ' bytes a ' +
      Ping1.HostName + ' (' + Ping1.HostIP + ')');
end;


procedure TformMenuPrincipal.Ping1EchoReply(Sender: TObject;
    Icmp: TObject; Error: Integer);
var
  MSecs, MSecsAve: integer;
begin
  if Error = 0 then
  begin
    mLog.Lines.Add('No se ha podido hacer ping al host (' +
        Ping1.HostIP + ') : ' + Ping1.ErrorString);
    MSecs := 0;
  end
  else
  begin
    mLog.Lines.Add('Recibidos ' + IntToStr(Ping1.Reply.DataSize) +
        ' bytes desde ' + Ping1.HostIP + ' en ' +
        IntToStr(Ping1.Reply.RTT) + ' msegs');
    MSecs := Ping1.Reply.RTT;
  end;

  Series1.Add(MSecs, IntToStr(numeroSaltos), clTeeColor);
  bCancelar.Enabled := true;

  Series2.Clear;

  if MSecs > MMax then
    MMax := MSecs;

  if MSecs < MMin then
   MMin := MSecs;

  MMed := MMed + MSecs;

  Series2.Add(MMax, 'Mx.', clTeeColor);
  Series2.Add(MMin, 'Mn.', clTeeColor);

  if numeroSaltos > 0 then
  begin
    MSecsAve := Round(MMed / numeroSaltos);
    Series2.Add(MSecsAve, 'Media', clTeeColor);
  end;

  Series2.Add(MSecs, 'Actual', clTeeColor);

  //retraso antes del siguienet ping
  if numeroSaltos > 0 then //0 si se ha cancelado el ping
    Timer1.Enabled := True;
end;


procedure TformMenuPrincipal.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  bPingClick (Sender);
end;

procedure TformMenuPrincipal.Series1AfterAdd(Sender: TChartSeries;
  ValueIndex: Integer);
begin
  With Sender.GetHorizAxis do
  begin
    Automatic := False;
    if numeroSaltos > 12 then
    begin
     Maximum := numeroSaltos;
     Minimum := Maximum - 12;
    end
    else
    begin
     Minimum := 0;
     Maximum := 12;
    end;
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  mLog.Align := alTop;

  Splitter1.Align := alTop;

  Chart2.Align := alBottom;
  Splitter2.Align := alBottom;

  Chart1.Align := alClient;
  txtHost.Text := txtHost.Items[0];
end;

procedure TformMenuPrincipal.ShowLegend1Click(Sender: TObject);
begin
  ShowLegend1.Checked := not ShowLegend1.Checked;
  Chart1.legend.Visible := ShowLegend1.Checked;
end;


procedure TformMenuPrincipal.ShowLabels1Click(Sender: TObject);
begin
  ShowLabels1.Checked := not ShowLabels1.Checked;
  Series1.Marks.Visible := ShowLabels1.Checked;
end;


procedure TformMenuPrincipal.ShowLegend2Click(Sender: TObject);
begin
  ShowLegend2.Checked := not ShowLegend2.Checked;
  Chart2.legend.Visible := ShowLegend2.Checked;
end;


procedure TformMenuPrincipal.ShowLabels2Click(Sender: TObject);
begin
  ShowLabels2.Checked := not ShowLabels2.Checked;
  Series2.Marks.Visible := ShowLabels2.Checked;
end;


procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  bCancelarClick (sender);
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.

